## com.google.common.math
Class BigIntegerMath

    java.lang.Object
      com.google.common.math.BigIntegerMath

    @Beta
    @GwtCompatible(emulated=true)
    public final class BigIntegerMath

extends Object

A class for arithmetic on values of type `BigInteger`.

The implementations of many methods in this class are based on material from Henry S. Warren, Jr.'s Hacker's Delight, (Addison Wesley, 2002).

Similar functionality for `int` and for `long` can be found in `IntMath` and `LongMath` respectively.

Since:
  11.0
Author:
  Louis Wasserman

Method Summary
`static BigInteger` `binomial(int n, int k)` Returns `n` choose `k`, also known as the binomial coefficient of `n` and `k`, that is, `n! / (k! (n - k)!)`.
`static BigInteger` `divide(BigInteger p, BigInteger q, RoundingMode mode)` Returns the result of dividing `p` by `q`, rounding using the specified `RoundingMode`.
`static BigInteger` `factorial(int n)` Returns `n!`, that is, the product of the first `n` positive integers, or `1` if `n == 0`.
`static boolean` `isPowerOfTwo(BigInteger x)` Returns `true` if `x` represents a power of two.
`static int` `log10(BigInteger x, RoundingMode mode)` Returns the base-10 logarithm of `x`, rounded according to the specified rounding mode.
`static int` `log2(BigInteger x, RoundingMode mode)` Returns the base-2 logarithm of `x`, rounded according to the specified rounding mode.
`static BigInteger` `sqrt(BigInteger x, RoundingMode mode)` Returns the square root of `x`, rounded with the specified rounding mode.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### isPowerOfTwo

    public static boolean isPowerOfTwo(BigInteger x)

  Returns `true` if `x` represents a power of two.

### log2

    public static int log2(BigInteger x,
                           RoundingMode mode)

  Returns the base-2 logarithm of `x`, rounded according to the specified rounding mode.

  Throws:
    `IllegalArgumentException` - if `x <= 0`
    `ArithmeticException` - if `mode` is `RoundingMode.UNNECESSARY` and `x` is not a power of two

### log10

    @GwtIncompatible(value="TODO")
    public static int log10(BigInteger x,
                                                 RoundingMode mode)

  Returns the base-10 logarithm of `x`, rounded according to the specified rounding mode.

  Throws:
    `IllegalArgumentException` - if `x <= 0`
    `ArithmeticException` - if `mode` is `RoundingMode.UNNECESSARY` and `x` is not a power of ten

### sqrt

    @GwtIncompatible(value="TODO")
    public static BigInteger sqrt(BigInteger x,
                                                       RoundingMode mode)

  Returns the square root of `x`, rounded with the specified rounding mode.

  Throws:
    `IllegalArgumentException` - if `x < 0`
    `ArithmeticException` - if `mode` is `RoundingMode.UNNECESSARY` and `sqrt(x)` is not an integer

### divide

    @GwtIncompatible(value="TODO")
    public static BigInteger divide(BigInteger p,
                                                         BigInteger q,
                                                         RoundingMode mode)

  Returns the result of dividing `p` by `q`, rounding using the specified `RoundingMode`.

  Throws:
    `ArithmeticException` - if `q == 0`, or if `mode == UNNECESSARY` and `a` is not an integer multiple of `b`

### factorial

    public static BigInteger factorial(int n)

  Returns `n!`, that is, the product of the first `n` positive integers, or `1` if `n == 0`.

  Warning: the result takes O(n log n) space, so use cautiously.

  This uses an efficient binary recursive algorithm to compute the factorial with balanced multiplies. It also removes all the 2s from the intermediate products (shifting them back in at the end).

  Throws:
    `IllegalArgumentException` - if `n < 0`

### binomial

    public static BigInteger binomial(int n,
                                      int k)

  Returns `n` choose `k`, also known as the binomial coefficient of `n` and `k`, that is, `n! / (k! (n - k)!)`.

  Warning: the result can take as much as O(k log n) space.

  Throws:
    `IllegalArgumentException` - if `n < 0`, `k < 0`, or `k > n`

Copyright © 2010-2012. All Rights Reserved.